package juliac.generated;

import org.osoa.sca.CallableReference;
import org.objectweb.fractal.api.Component;
import java.lang.reflect.Constructor;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.ow2.frascati.tinfi.control.component.ReconfigurableComponentContext;
import org.osoa.sca.RequestContext;
import org.ow2.frascati.tinfi.control.content.SCAContentController;
import org.ow2.frascati.tinfi.control.property.SCAPropertyController;
import org.osoa.sca.ServiceReference;
import org.ow2.frascati.tinfi.osoa.ServiceReferenceImpl;
import java.util.Stack;
import org.ow2.frascati.tinfi.TinfiRuntimeException;
import org.objectweb.fractal.api.Type;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin
 * @see org.ow2.frascati.tinfi.control.property.UseSCAPropertyControllerMixin
 * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin
 */
public class SCAComponentContextControllerImpl implements Controller , Generated , ReconfigurableComponentContext {
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weavableSCACC = ((SCAContentController)(ic.interfaces.get(SCAContentController.NAME)));
        initFcController$1(ic);
    }
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.ow2.frascati.tinfi.control.property.UseSCAPropertyControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weavablePC = ((SCAPropertyController)(ic.interfaces.get(SCAPropertyController.NAME)));
        initFcController$0(ic);
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * Does nothing.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * Returns the absolute URI of the component within the SCA Domain.
     *
     * @return the absolute URI of the component
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getURI()
     */
    public String getURI() {
        throw new UnsupportedOperationException();
    }
    
    /** 
     * The {@link Component} interface of the component to which this controller
     * object belongs.
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin#weavableSCACC
     */
    @SuppressWarnings(value = "unused")
    private SCAContentController weavableSCACC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.UseSCAPropertyControllerMixin#weavablePC
     */
    @SuppressWarnings(value = "unused")
    private SCAPropertyController weavablePC;
    
    /** 
     * Initializes the fields of this mixin and then calls the overriden method.
     * 
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$2(ic);
    }
    
    /** 
     * Cast a type-safe reference to a CallableReference.
     * Converts a type-safe reference to an equivalent CallableReference; if the target refers to a service
     * then a ServiceReference will be returned, if the target refers to a callback then a CallableReference
     * will be returned.
     *
     * @param target a reference proxy provided by the SCA runtime
     * @param <B> the Java type of the business interface for the reference
     * @param <R> the type of reference to be returned
     * @return a CallableReference equivalent for the proxy
     * @throws IllegalArgumentException if the supplied instance is not a reference supplied by the SCA runtime
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#cast(B)
     */
    public <B, R extends org.osoa.sca.CallableReference<B>> R cast(B target) throws IllegalArgumentException {
        if (!(target instanceof ServiceReference)) {
            String msg = "Not a reference: " + target;
            throw new IllegalArgumentException(msg);
        } 
        ServiceReference<?>  ci = ((ServiceReference<?> )(target));
        Class<?>  businessInterface = ci.getBusinessInterface();
        Object service = ci.getService();
        String signature = businessInterface.getName();
        String clname = signature + "FcSR";
        try {
            Class<?>  cl = Class.forName(clname);
            Constructor<?> [] ctrs = cl.getConstructors();
            Constructor<?>  ctr = ctrs[0];
            Object sr = ctr.newInstance(businessInterface ,service);
            return ((R)(sr));
        } catch (Exception e) {
            throw new IllegalArgumentException(e);
        }
    }
    
    /** 
     * The {@link Controller#initFcController initFcController} method overriden
     * by this mixin.
     *
     * @param ic information about the component to which this controller object
     *      belongs.
     * @throws InstantiationException if the initialization fails.
     */
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * Returns a proxy for a reference defined by this component.
     *
     * @param businessInterface the interface that will be used to invoke the service
     * @param referenceName the name of the reference
     * @return an object that implements the business interface
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getService(java.lang.Class,java.lang.String)
     */
    public <B> B getService(Class<B>  businessInterface, String referenceName) throws TinfiRuntimeException {
        try {
            Interface itf = ((Interface)(weaveableC.getFcInterface(referenceName)));
            InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
            if (!(it.isFcClientItf())) {
                String msg = "No such reference: " + referenceName;
                throw new TinfiRuntimeException(msg);
            } 
            if (!(businessInterface.isAssignableFrom(itf.getClass()))) {
                String msg = "Reference can not be casted to: " + (businessInterface.getClass());
                throw new TinfiRuntimeException(msg);
            } 
            return ((B)(itf));
        } catch (NoSuchInterfaceException e) {
            throw new TinfiRuntimeException(e);
        }
    }
    
    /** 
     * Returns a ServiceReference for a reference defined by this component.
     *
     * @param businessInterface the interface that will be used to invoke the service
     * @param referenceName the name of the reference
     * @return a ServiceReference for the designated reference
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getServiceReference(java.lang.Class,java.lang.String)
     */
    public <B> ServiceReference<B>  getServiceReference(Class<B>  businessInterface, String referenceName) {
        B service = getService(businessInterface ,referenceName);
        ServiceReference<B>  sr = new ServiceReferenceImpl<B> (businessInterface , service);
        return sr;
    }
    
    /** 
     * Returns the value of an SCA property defined by this component.
     *
     * @param type the Java type to be returned for the property
     * @param propertyName the name of the property whose value should be returned
     * @return the property value
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getProperty(java.lang.Class,java.lang.String)
     */
    public <B> B getProperty(Class<B>  type, String propertyName) throws IllegalArgumentException {
        if (!(weavablePC.containsKey(propertyName))) {
            String msg = "No such property: " + propertyName;
            throw new IllegalArgumentException(msg);
        } 
        Object value = weavablePC.get(propertyName);
        try {
            return ((B)(value));
        } catch (ClassCastException cce) {
            String msg = (("Property " + propertyName) + " is not of type ") + (type.getName());
            throw new IllegalArgumentException(msg);
        }
    }
    
    /** 
     * Returns a ServiceReference that can be used to invoke this component over
     * the default service.
     *
     * @param businessInterface the interface that will be used to invoke the service
     * @return a ServiceReference that will invoke this component
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#createSelfReference(java.lang.Class)
     */
    public <B> ServiceReference<B>  createSelfReference(Class<B>  businessInterface) {
        B service = getServ(businessInterface);
        ServiceReference<B>  sr = new ServiceReferenceImpl<B> (businessInterface , service);
        return sr;
    }
    
    /** 
     * Returns a ServiceReference that can be used to invoke this component over
     * the designated service.
     *
     * @param businessInterface the interface that will be used to invoke the service
     * @param serviceName the name of the service to invoke
     * @return a ServiceReference that will invoke this component
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#createSelfReference(java.lang.Class,java.lang.String)
     */
    public <B> ServiceReference<B>  createSelfReference(Class<B>  businessInterface, String serviceName) {
        B service = getServ(businessInterface ,serviceName);
        ServiceReference<B>  sr = new ServiceReferenceImpl<B> (businessInterface , service);
        return sr;
    }
    
    /** 
     * Returns the context for the current SCA service request, or null if there
     * is no current request or if the context is unavailable.
     *
     * @return the SCA request context; may be null
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getRequestContext()
     */
    public RequestContext getRequestContext() {
        Stack<org.osoa.sca.RequestContext>  stack = weavableSCACC.getRequestContextStack();
        RequestContext top = stack.peek();
        return top;
    }
    
    /** 
     * Return the reference of the component controller associated with this
     * controller.
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getFcComponent()
     */
    public Component getFcComponent() {
        return weaveableC;
    }
    
    /** 
     * Returns a proxy for the default service defined by this component.
     * The default service is defined as the first server interface found in the
     * list of interfaces associated with this component.
     *
     * @param businessInterface the interface that will be used to invoke the service
     * @param serviceName the name of the reference
     * @return an object that implements the business interface
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getServ(java.lang.Class)
     */
    private <B> B getServ(Class<B>  businessInterface) throws TinfiRuntimeException {
        Object[] itfs = weaveableC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
            if (!(it.isFcClientItf())) {
                if (businessInterface.isAssignableFrom(itf.getClass())) {
                    return ((B)(itf));
                } 
            } 
        }
        String msg = "No such default service";
        throw new TinfiRuntimeException(msg);
    }
    
    /** 
     * Returns a proxy for a service defined by this component.
     *
     * @param businessInterface the interface that will be used to invoke the service
     * @param serviceName the name of the reference
     * @return an object that implements the business interface
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getServ(java.lang.Class,java.lang.String)
     */
    private <B> B getServ(Class<B>  businessInterface, String serviceName) throws TinfiRuntimeException {
        try {
            Interface itf = ((Interface)(weaveableC.getFcInterface(serviceName)));
            InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
            if (it.isFcClientItf()) {
                String msg = "No such service: " + serviceName;
                throw new TinfiRuntimeException(msg);
            } 
            if (!(businessInterface.isAssignableFrom(itf.getClass()))) {
                String msg = "Service can not be casted to: " + (businessInterface.getClass());
                throw new TinfiRuntimeException(msg);
            } 
            return ((B)(itf));
        } catch (NoSuchInterfaceException e) {
            throw new TinfiRuntimeException(e);
        }
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAComponentContextControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin org.ow2.frascati.tinfi.control.property.UseSCAPropertyControllerMixin org.ow2.frascati.tinfi.control.component.ComponentContextMixin)";
    }
    
}

